<?php
/*
Theme Name: BIZ-Concept
Theme URI:
Description: 
Author: Helen RIPLEY - Biz-Concept.net
Author URI: https://biz-concept.net
Template: 
Version: 0.1.0 (Initial revision)
Text Domain: twentyseventeen-child
License: GNU General Public License v2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
Tags: WP fr_FR dummy forced french feminisation removal
*/

	//Structure de filtre des mots en Anglais dont la traduction WordPress est inutilement féminisée en Français
	//0-Anglais
	//1-Français
	//2-1-Singulier
	//2-2-Pluriel et singulier
	//2-3-Remplacement (Chaîne2 => Chaîne 1)
	define ('BC_INCLUSIVE_FILTERS', array (
							array ( "admins", "", array( array("/administratrices",2) ) ),
							array ( "administrator", "administratrice", array( array(" ou l’administratrice",1), array(" ou à l’administratrice",1),array(" ou de l’administratrice",1), array("ou d’administratrice",1), array(" ou une administratrice",1),  array(" et les administratrices",1), array(", administratrice",1), array(" ou administratrices",2), array("/administratrices",2), array("eur·ice",1), array("eurs·ices",1) ) ),
							array ( "author", "autrice", array( array(" ou l’autrice",1), array(" ou de l’autrice",1), array("ou d’autrice",1), array(" ou une autrice",1),array(" ou autrices",2), array(" et autrices",2), array("/autrices",2), array("eur·ice",1), array("eurs·ices",1) ) ),
							array ( "contributor", "contributrice", array(  array("ontributrices & c",1), array(" et contributrices",2), array("/contributrices",2), array("eur·ice",1), array("eurs·ices",1) ) ),
							array ( "developer", "développeuse", array( array(" et les développeuses",1), array(" une développeuse ou",1 ) ) ),
							array ( "editor", "éditrice", array( array(" ou éditrices",2), array("/éditrices",2), array("eur·ice",1), array("eurs·ices",1) ) ),
							array ( "subscriber", "abonnée", array( array(" et abonnées",1), array("/abonnées",2) ) ),
							array ( "user", "utilisatrice", array( array(" et d’utilisatrices",2), array(" et l’utilisatrice",1), array(" ou à l’utilisatrice",1), array(" ou de l’utilisatrice",1), array("l’utilisatrice ou à ",1), array(" ou l’utilisatrice",1), array(" ou utilisatrice",1), array(" ou une utilisatrice",1), array("d’utilisatrices et ",1), array("outes les utilisatrices et t",1), array(" utilisatrices et",1), array(" ou utilisatrices",2), array(" et utilisatrices",2), array(" ou de utilisatrice",1),array("/utilisatrices",2), array("eur·ice",1), array("eurs·ices",1), array("é·e",1) ) ),
							array ( "ready", "", array( array("⋅e",1), array("·e",1) ) ) )
						 );

	/**
	 ** Récupération de la structure des traductions (Mode non genré dit "inclusif")
	 ** Vers.: 0.1.0 (Initiale)
	 ** Usage: Traductions
	 ** @return array             Structure du filtre utilisé (Défaut ou fichier de mise à jour).
	 **/
	function CT_get_inclusive_filters()
	{
		//Répertoire de stockage (CT_get_inclusive_filters)
		$sFilePath = WP_LANG_DIR . '/fr_FR-76a3b7a44aa504aa6013921fe3581b4a.json';
		
		//Chargement des données du fichier
		$rawData = is_file( $sFilePath ) && is_readable( $sFilePath ) ? file_get_contents( $sFilePath ) : false;
		
		//Traitement des données du fichier
		if($rawData)
		{
			//Mise en forme des données
			$aRawData = json_decode($rawData);
			
			//Acquisition des nouveaux filtres
			$aNewFilter = array();
			foreach ($aRawData->locale_data->messages as $mKey => $values)
			{
				$aNewFilter[$mKey]= (array)$values;
			}
			return($aNewFilter);
		}
		
		return BC_INCLUSIVE_FILTERS;
	}

	/**
	 ** Recherche de noms (féminins [possiblement inclusifs]) dans un fichier de traduction .PO (Mode non genré dit "inclusif")
	 ** Vers.: 0.1.0 (Initiale)
	 ** Usage: Traductions
	 ** @param  string            $sFilePath	Chemin du fichier de traduction à contrôler.
	 ** @return bool true Si des noms ont été détectés, sinon false.
	 **/
	function CT_check_inclusive_POfile($sFilePath)
	{
		//Initialisation
		$aWords = array();
		$iKey = 0;
		
		//Chargement des filtres à mettre en oeuvre
		$aFilters = CT_get_inclusive_filters();
		
		//Constitution de la liste des noms (féminins) à tester
		foreach($aFilters as $aPhrases){
			if (!(empty($aPhrases[1])))
			{
				$aWords[$iKey]= $aPhrases[1];
				$iKey ++;
			}
		}
		
		//Chargement des données du fichier
		$rawData = is_file( $sFilePath ) && is_readable( $sFilePath ) ? file_get_contents( $sFilePath ) : false;
		
		//Présence d'un nom (féminin [possiblement inclusif]) dans les données du fichier
		if ($rawData)
			foreach ($aWords as $aWord)
			{
				$pos = strpos(strtolower($rawData),$aWord);
				if ($pos !== false) 
				{
					return(true);
				}
			}
		return false;
	}

 	/**
	 ** Recherche et modification d'un texte dans une chaine
	 ** Vers.: 0.1.0 (Initiale)
	 ** Usage: Traductions
	 ** @param  string            $search		Valeur à rechercher.
	 ** @param  string            $replace		Valeur de remplacement à substituer aux valeurs trouvées.
	 ** @param  string            $subject		La chaîne dans laquelle on va effectuer la recherche
	 ** @return string            $subject 		La chaîne mise à jour si la valeur a été trouvée réussi, sinon la chaîne originale.
	 **/
	function CT_search_replace_text($search, $replace, $subject)
	{
		//Présence du texte recherché
		$pos = strpos($subject, $search);
		if ($pos !== false) 
		{
			//Remplacement du texte
			$subject = str_replace($search, $replace, $subject);
		}
		return ($subject);
	}

 	/**
	 ** Filtre des traductions WP fr_FR (Mode non genré dit "inclusif") à partir du texte original en anglais
	 ** Vers.: 0.1.0 (Initiale)
	 ** Usage: Traductions
	 ** @param  string            $translated   Traduction (Mode non genré dit "inclusif").
	 ** @param  string            $original     Texte original en anglais.
	 ** @param  string            $domain       Domaine du texte. (A titre de comptatibilité si utilisé avec le filtre 'gettext')
	 ** @return string 			  $translated   Traduction en français correct.
	 **/
	function CT_WP_remove_dummy_forced_french_feminisation( $translated, $original, $domain)
	{
		//Chargement des filtres à mettre en oeuvre
		$aFilters = CT_get_inclusive_filters();
		
		//Recherche du mot en Anglais : Admins, Administrator, Author, Contributor, Developer, Editor, Subscriber, User
		foreach ($aFilters as $aPhrase)
		{
			//Présence du mot en Anglais
			$pos = strpos(strtolower($original), $aPhrase[0]);
			if ($pos !== false)
			{
				//Mise à jour des traductions en Français
				foreach ($aPhrase[2] as $aTraduction)
				{
					//Traitement des remplacements
					if ($aTraduction[1]==3)
					{
						$translated = CT_search_replace_text($aTraduction[0], $aTraduction[2], $translated);
					} else {
						$check = $aTraduction[0];
						$replace = '';
						
						//Filtre des expressions inclusives
						$pos = strpos($check, '·');
						if ($pos !== false)
							$replace = substr($check, 0, $pos);
						
						$translated = CT_search_replace_text($check, $replace, $translated);
						
						//Traitement des pluriels
						if ($aTraduction[1]==2)
						{
							$check = substr($aTraduction[0], 0, -1);
							$translated = CT_search_replace_text($check, '', $translated);
						}
					}
				}
			}
		}
		return $translated;
	}
?>
